<template>
  <div>
    <div class="row q-pa-md justify-between">
      <div class="row">
        <div class="exam-btn exam-btn-blue row">
          <div class="exam-btn-icon">
            <img src="../../public/module_white.svg" alt="" />
          </div>
          <div class="exam-btn-label">Module</div>
        </div>
        <div style="width: 15px"></div>
        <div class="exam-btn exam-btn-white row">
          <div class="exam-btn-icon">
            <img src="../../public/exam.svg" alt="" />
          </div>
          <div class="exam-btn-label" @click="examBtn()">Exam</div>
        </div>
      </div>
      <div class="exam-btn-module row">
        <div class="exam-btn-label" @click="addModuleBtn()">+ Add module</div>
      </div>
    </div>

    <div class="q-pa-md">
      <q-table
        :data="data"
        :pagination.sync="pagination"
        :columns="columns"
        flat
        bordered
      >
        <template v-slot:body="props">
          <q-tr :props="props">
            <q-td key="orderid" :props="props" style="width: 50px">{{
              props.row.orderid
            }}</q-td>
            <q-td key="name" :props="props">{{ props.row.name }}</q-td>
            <q-td key="question" :props="props" style="width: 100px"
              >{{ props.row.used }} / {{ props.row.total }}</q-td
            >

            <q-td key="edit" :props="props" style="width: 100px">
              <div
                class="q-py-sm cursor-pointer"
                @click="editModuleBtn(props.row.id)"
              >
                <u>edit</u>
              </div>
            </q-td>
            <q-td key="delete" :props="props" style="width: 100px">
              <div
                class="q-py-sm cursor-pointer"
                @click="delModuleBtn(props.row.id)"
              >
                <u>delete</u>
              </div>
            </q-td>
          </q-tr>
        </template>
      </q-table>
    </div>

    <!-- Add dialog -->
    <q-dialog v-model="addModuleDialog">
      <q-card class="user-dialog q-pa-md">
        <div class="text-h6">Add module</div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">Order id</div>
          <div class="col">
            <q-input v-model="input.orderid" outlined dense type="number" />
          </div>
        </div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">Module name</div>
          <div class="col">
            <q-input v-model="input.name" outlined dense />
          </div>
        </div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">Used question</div>
          <div class="col">
            <q-input v-model="input.used" outlined dense type="number" />
          </div>
        </div>

        <div class="row q-pt-md justify-center">
          <div>
            <q-btn
              label="Cancel"
              outline
              class="short-btn"
              @click="closeAddModuleDialog()"
            />
          </div>
          <div style="width: 15px"></div>
          <div>
            <q-btn
              label="Save"
              class="short-btn active-btn"
              @click="saveAddModule()"
            />
          </div>
        </div>
      </q-card>
    </q-dialog>
    <!-- Edit dialog -->
    <q-dialog v-model="editModuleDialog">
      <q-card class="user-dialog q-pa-md">
        <div class="text-h6">Edit module</div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">Order id</div>
          <div class="col">
            <q-input v-model="input.orderid" outlined dense type="number" />
          </div>
        </div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">Module name</div>
          <div class="col">
            <q-input v-model="input.name" outlined dense />
          </div>
        </div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">Used question</div>
          <div class="col">
            <q-input v-model="input.used" outlined dense type="number" />
          </div>
        </div>

        <div class="row q-pt-md justify-center">
          <div>
            <q-btn
              label="Cancel"
              outline
              class="short-btn"
              @click="closeEditModuleDialog()"
            />
          </div>
          <div style="width: 15px"></div>
          <div>
            <q-btn
              label="Save"
              class="short-btn active-btn"
              @click="saveEditModule()"
            />
          </div>
        </div>
      </q-card>
    </q-dialog>
    <!-- alert delete dialog  -->
    <q-dialog v-model="delDialog" persistent>
      <q-card>
        <q-card-section>
          <div class="titleDialog">Delete module</div>

          <hr style="width: 400px" />
          <div align="center">
            <div>Do you want to delete this module?</div>
          </div>
        </q-card-section>
        <q-card-actions align="center">
          <div class="row">
            <q-btn
              label="Cancel"
              outline
              class="short-btn"
              @click="closeDelDia()"
            />

            <div style="width: 15px"></div>
            <q-btn
              label="Yes"
              class="short-btn active-btn"
              @click="confirmDelBtn()"
            />
          </div>
        </q-card-actions>
        <br />
      </q-card>
    </q-dialog>
  </div>
</template>

<script>
import axios from "axios";
export default {
  data() {
    return {
      input: {
        id: 0,
        orderid: 0,
        name: "",
        used: 1,
      },
      addModuleDialog: false,
      delDialog: false,
      editModuleDialog: false,
      delID: "",
      pagination: {
        rowsPerPage: 50,
      },
      columns: [
        {
          name: "orderid",
          label: "Order id",
          align: "center",
        },
        { name: "name", label: "Module name", align: "left" },
        { name: "question", label: "Used / total question", align: "center" },

        { name: "edit", label: "Edit", align: "center" },
        { name: "delete", label: "Delete", align: "center" },
      ],
      data: [
        {
          id: 1,
          orderid: 100,
          name: "Module A.1 Trade and the Sustainable Development Goals (SDGs), a general overview",
          used: 3,
          total: 5,
        },
        {
          id: 2,
          orderid: 200,
          name: "Module A.2 Trade and development: tools and trends",
          used: 4,
          total: 7,
        },
      ],
    };
  },
  methods: {
    examBtn() {
      this.$emit("examBtn");
    },
    async saveEditModule() {
      if (this.input.orderid > 0 && this.input.name.length > 0) {
        let url = this.serverpath + "editmodule.php";
        let res = await axios.post(url, JSON.stringify(this.input));
        if (res.data == "finish") {
          this.greenNotify("save complete");
          this.loadModule();
        } else {
          this.redNotify("save incomplete");
        }

        this.editModuleDialog = false;
      } else {
        this.redNotify("Username and password must be at least 6 characters.");
      }
    },
    closeEditModuleDialog() {
      this.editModuleDialog = false;
    },
    editModuleBtn(id) {
      this.editModuleDialog = true;
      let dataEdit = this.data.filter((x) => x.id == id);
      this.input.orderid = dataEdit[0].orderid;
      this.input.name = dataEdit[0].name;
      this.input.used = dataEdit[0].used;
      this.input.id = dataEdit[0].id;
    },
    closeDelDia() {
      this.delDialog = false;
    },
    delModuleBtn(id) {
      this.delID = id;
      this.delDialog = true;
    },
    async confirmDelBtn() {
      let dataSend = {
        id: this.delID,
      };
      let url = this.serverpath + "delmodule.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      if (res.data == "finish") {
        this.greenNotify("delete complete");
        this.loadModule();
      } else {
        this.redNotify("delete incomplete");
      }
      this.delDialog = false;
    },
    async saveAddModule() {
      if (this.input.orderid > 0 && this.input.name.length > 0) {
        let url = this.serverpath + "addnewmodule.php";
        let res = await axios.post(url, JSON.stringify(this.input));
        if (res.data == "finish") {
          this.greenNotify("save complete");
          this.loadModule();
        } else {
          this.redNotify("save incomplete");
        }

        this.addModuleDialog = false;
      } else {
        this.redNotify("Username and password must be at least 6 characters.");
      }
    },
    closeAddModuleDialog() {
      this.addModuleDialog = false;
    },
    addModuleBtn() {
      this.addModuleDialog = true;
      this.input.orderid = "";
      this.input.name = "";
      this.input.used = 0;
    },
    async loadModule() {
      let key = this.$q.localStorage.getItem("key");
      let dataSend = { key: key };
      let url = this.serverpath + "loadmodule.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      if (res.data == "go to examinee") {
        this.$router.push("/examinee");
      } else if (res.data == "go to login") {
        this.$q.localStorage.clear();
        this.$router.push("/");
      } else {
        this.data = res.data;
        this.data.forEach((item, index) => {
          item.no = index + 1;
        });
      }
    },
  },
  mounted() {
    this.loadModule();
  },
};
</script>

<style lang="scss" scoped>
.exam-btn {
  width: 120px;
  height: 40px;
  border-radius: 5px;
  font-size: 18px;
}
.exam-btn-blue {
  background-color: #41aaf2;
  color: white;
}
.exam-btn-icon {
  padding-top: 5px;
  padding-left: 10px;
}
.exam-btn-label {
  padding-top: 6px;
  padding-left: 10px;
}
.exam-btn-white {
  border: 1px solid #4f4f4f;
  cursor: pointer;
}
.exam-btn-module {
  width: 140px;
  height: 40px;
  border-radius: 5px;
  font-size: 18px;
  border: 1px solid #4f4f4f;
  cursor: pointer;
}
.user-dialog {
  min-width: 900px;
  height: 300px;
}
.user-add-label {
  width: 120px;
  padding-top: 10px;
}
</style>
